# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag .redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           org.osgi
Version:        4.2.0
Release:        4%{?reltag}%{?dist}.3
Epoch:          0
Summary:        OSGi core, compendium, and enterprise
License:        ASL 2.0
Group:          Development/Java
URL:            http://www.osgi.org
%if 0
svn -q export -r 3050 https://svn.devel.redhat.com/repos/jboss-tck/osgitck/r4v42 org.osgi-4.2.0 && tar cjf org.osgi-4.2.0.tar.bz2 org.osgi-4.2.0
%endif
Source0:        org.osgi-4.2.0.tar.bz2
Source1:        http://repo1.maven.org/maven2/org/osgi/org.osgi.core/4.2.0/org.osgi.core-4.2.0.pom
Source2:        http://repo1.maven.org/maven2/org/osgi/org.osgi.compendium/4.2.0/org.osgi.compendium-4.2.0.pom
Source3:        http://repo1.maven.org/maven2/org/osgi/org.osgi.enterprise/4.2.0/org.osgi.enterprise-4.2.0.pom
Patch0:         org.osgi-pom-versions.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  jboss-parent
BuildRequires:  maven2-plugin-deploy
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
OSGi core, compendium, and enterprise.

%package -n org.osgi.core
Summary:        OSGi core
Group:          Development/Java
Version:        %{version}

%description -n org.osgi.core
OSGi core.

%package -n org.osgi.compendium
Summary:        OSGi compendium
Group:          Development/Java
Version:        %{version}

%description -n org.osgi.compendium
OSGi compendium.

%package -n org.osgi.enterprise
Summary:        OSGi enterprise
Group:          Development/Java
Version:        %{version}

%description -n org.osgi.enterprise
OSGi enterprise.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation
Requires:       jpackage-utils
Provides:       org.osgi.core-javadoc = %{epoch}:%{version}-%{release}
Provides:       org.osgi.compendium-javadoc = %{epoch}:%{version}-%{release}
Provides:       org.osgi.enterprise-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      org.osgi.core-javadoc < %{epoch}:%{version}-%{release}
Obsoletes:      org.osgi.compendium-javadoc < %{epoch}:%{version}-%{release}
Obsoletes:      org.osgi.enterprise-javadoc < %{epoch}:%{version}-%{release}

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
# FIXME: Can't remove any of these since we need the OSGi support in the jars
%{_bindir}/find -type f \( -name "*.jar" -and -not -name org.osgi.tools.btool-latest.jar -and -not -name biz.aQute.bnd-latest.jar -and -not -name com.springsource.junit-3.8.2.jar -and -not -name org.eclipse.osgi-3.5.1.jar -and -not -name ee.foundation-1.1.0.jar -and -name osgi.core-4.1.0.jar -and -not -name net.sf.antcontrib-latest.jar \) | %{_bindir}/xargs -t %{__rm}
%{__rm} -r licensed/ant
%{__cp} -p %{SOURCE1} %{SOURCE2} %{SOURCE3} .
%patch0 -p1 -b .sav0

%build
export LC_ALL=en_US.UTF-8
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} build-libs
%if 0
pushd osgi.companion
%{ant}
popd
%endif
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=org.osgi.core-%{version}.pom -Dfile=osgi.companion/generated/osgi.core.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=org.osgi.compendium-%{version}.pom -Dfile=osgi.companion/generated/osgi.cmpn.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=org.osgi.enterprise-%{version}.pom -Dfile=osgi.companion/generated/osgi.enterprise.jar -Durl=${URL} -DrepositoryId=oss-releases

%install
%{__rm} -rf %{buildroot}

# jar
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p osgi.companion/generated/osgi.core.jar %{buildroot}%{_javadir}/org.osgi.core-%{namedversion}.jar
%{__cp} -p osgi.companion/generated/osgi.cmpn.jar %{buildroot}%{_javadir}/org.osgi.compendium-%{namedversion}.jar
%{__cp} -p osgi.companion/generated/osgi.enterprise.jar %{buildroot}%{_javadir}/org.osgi.enterprise-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} ${jar/-%{namedversion}/}; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org.osgi.core-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-org.osgi.core.pom
%add_to_maven_depmap org.osgi org.osgi.core %{namedversion} JPP org.osgi.core
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/org.osgi.core
%{__cp} -p org.osgi.compendium-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-org.osgi.compendium.pom
%add_to_maven_depmap org.osgi org.osgi.compendium %{namedversion} JPP org.osgi.compendium
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/org.osgi.compendium
%{__cp} -p org.osgi.enterprise-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-org.osgi.enterprise.pom
%add_to_maven_depmap org.osgi org.osgi.enterprise %{namedversion} JPP org.osgi.enterprise
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/org.osgi.enterprise

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr osgi.companion/generated/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%__rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files -n org.osgi.core
%defattr(0644,root,root,0755)
%{_javadir}*/org.osgi.core-%{namedversion}.jar
%{_javadir}*/org.osgi.core.jar
%{_datadir}/maven2/poms/JPP-org.osgi.core.pom
%{_mavendepmapfragdir}/org.osgi.core

%files -n org.osgi.compendium
%defattr(0644,root,root,0755)
%{_javadir}*/org.osgi.compendium-%{namedversion}.jar
%{_javadir}*/org.osgi.compendium.jar
%{_datadir}/maven2/poms/JPP-org.osgi.compendium.pom
%{_mavendepmapfragdir}/org.osgi.compendium

%files -n org.osgi.enterprise
%defattr(0644,root,root,0755)
%{_javadir}*/org.osgi.enterprise-%{namedversion}.jar
%{_javadir}*/org.osgi.enterprise.jar
%{_datadir}/maven2/poms/JPP-org.osgi.enterprise.pom
%{_mavendepmapfragdir}/org.osgi.enterprise

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sat Sep 01 2012 Paul Gier <pgier@redhat.com> - 0:4.2.0-4.redhat_2.3
- Update pom patch for new jboss-parent

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.2.0-4.redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.2.0-4.redhat_1.1
- Rebuild using cache signing

* Wed May 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.2.0-4.redhat_1
- Use jboss-parent 8-redhat-1

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:4.2.0-3_redhat_1.1
- Rebuild using cache signing

* Fri Feb 10 2012 David Walluck <dwalluck@redhat.com> 0:4.2.0-3
- rebuild to resign

* Fri Sep 30 2011 David Walluck <dwalluck@redhat.com> 0:4.2.0-2
- BuildRequires: jboss-parent
- bump Release so that it is newer than obsolete packages

* Fri Sep 30 2011 David Walluck <dwalluck@redhat.com> 0:4.2.0-0.1
- release
